<?php
##======================================================##
##  365 image bbs admin                                 ##
##  Copyright (C) php365.com All rights reserved.       ##
##  http://php365.com/                                  ##
##======================================================##
// デフォルト設定ライブラリ
require_once("./lib/config.php");
// データベース操作ライブラリ
require_once(PATH_LIB.DBSTR.".php");
// 共通仕様サブルーチン
require_once(PATH_LIB."common.php");
#--------------------------------------------------------#

$script_name4html = t2h($_SERVER['SCRIPT_NAME']);
switch($_SERVER['REQUEST_METHOD']):
	case 'GET':
		if(!isset($_GET['mode'])){	login(true);exit; }
		switch($_GET['mode']):
			case 'check':
				check();
				break;
			case 'logout':	// ログアウト
				logout();
				break;
			default:
				login(true);
				break;
		endswitch;
		break;
	case 'POST':
		if(!isset($_POST['mode'])){	error("不正なリクエストです、LINE=".__LINE__); }
		switch($_POST['mode']):
			case 'modify':		// 記事編集
				modify();
				break;
			case 'do_modify':	// データ修正処理
				decode();
				do_modify();
				break;
			case 'delete':		// 記事一括削除
				delete();
				break;
			case 'allow':		// 画像承認
				allow();
				break;
			case 'login':		// ログイン
				decode();
				login();
				break;
			default:
				error("不正なリクエストです、LINE=".__LINE__);
				break;
		endswitch;
		break;
	default:
		error("不正なリクエストです、LINE=".__LINE__);
		break;
endswitch;
exit;
#----------------------#
#  管理室初期画面表示  #
#----------------------#
function show_top_html_admin(){
	global $CNF,$COLORS,$script_name4html,$title_name;

	$db = new DB(DBHOST,DBUSER,DBPASS,DBNAME);
	$sql = "SELECT count(*) FROM ".DBPREFIX."master WHERE ref = 0";
	$rows_all = $db->get_count($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
	if($rows_all == 0){
		$list_detail = "<p align=\"center\">対象データー：0件</p>";
		require(PATH_TEMPLATE."do_login.html");
		exit;
	}

	if(isset($_GET['p']) && intval($_GET['p']) > 0){
		$pagenow = intval($_GET['p']);
	}else{
		$pagenow = 1;
	}

	$write_flg = 0;
	$list_detail = "";
	$num_start = ($pagenow - 1) * PAGEVIEW + 1;
	$offset = $num_start - 1;

	$list_detail .= <<<EOM
<br>\n<form action="{$script_name4html}" method="post">
<font color="#CC6633">▼</font>処理する記事にチェックして処理するモードを選択して送信ボタン押して下さい。 <br>
<input type="hidden" name="pass" value="{$_POST['pass']}">
<select name="mode">
<option value="modify">記事編集
<option value="delete">記事削除
<option value="allow">画像承認
</option>
</select>
&nbsp;<input type="submit" value="送信する" onclick='return confirm("処理を開始します。よろしいですか？")'><br><br>
<table border="0" cellspacing="1" cellpadding="4" width="100%" class="solid_t">
<tr>
  <th class="bg" width="30" nowrap align="center"><font color="#FFFFFF">削除</font></th>
  <th class="bg" width="30" nowrap align="center"><font color="#FFFFFF">編集</font></th>
  <th class="bg" width="30" nowrap align="center"><font color="#FFFFFF">No.</font></th>
  <th class="bg" width="30" nowrap align="center"><font color="#FFFFFF">記事</font></th>
  <th class="bg" width="100" nowrap align="center"><font color="#FFFFFF">タイトル</font></th>
  <th class="bg" nowrap align="center"><font color="#FFFFFF">コメント(表示、非表示はタイトルをクリック)</font></th>
  <th class="bg" width="80" nowrap align="center"><font color="#FFFFFF">投稿者</font></th>
  <th class="bg" width="100" nowrap align="center"><font color="#FFFFFF">最終更新日</font></th>
  <th class="bg" width="30" nowrap align="center"><font color="#FFFFFF">画像</font></th>
  <th class="bg" width="30" nowrap align="center"><font color="#FFFFFF">承認</font></th>
  <th class="bg" width="50" nowrap align="center"><font color="#FFFFFF">画像承認</font></th>
  <th class="bg" width="40" align="center"><font color="#FFFFFF">ホスト名</font></th>
</tr>\n
EOM;

	$sql = "SELECT id FROM ".DBPREFIX."master WHERE ref = 0";
	$sql .= " ORDER BY lastmodify DESC ";
	$sql .= "limit {$offset}, ".PAGEVIEW;
	$items_main = $db->get_rows($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
	foreach($items_main as $item_main){
		$sql = "SELECT * FROM ".DBPREFIX."master WHERE id = {$item_main['id']} OR ref = {$item_main['id']} ORDER BY id, ref";
		$items = $db->get_rows($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
		foreach($items as $item){
			if($item['name'] == ""){	$item['name'] = NONAME;		}
			if($item['title'] == ""){	$item['title'] = NOTITLE;	}
			if($item['email']){
				$name_tag = "<a href=\"mailto:{$item['email']}\">{$item['name']}</a>";
			}else{
				$name_tag = $item['name'];
			}
			if(strstr($name_tag, TRIP_SIGN)){
				$name_tag = "<font color=\"".TRIP_COLOR."\">{$name_tag}</font>";
			}
			$comment = "<font color=\"{$COLORS[$item['color']]}\">{$item['comment']}</font>";
			if(!empty($item['img_ex'])){
				$imgname = PATH_IMG . $item['id'] . "." . $item['img_ex'];
				$kb = ceil(filesize($imgname) / 1024);
				$kb = number_format($kb);
				$str_img = "<a href=\"{$imgname}\" target=\"_blank\">画像</a><br>({$kb} KB)";
				if(intval($item['img_check']) == 1){
					$status_img = "<font color=\"#CC0000\">済</font>";
					$str_img_allow = "&nbsp;";
				}else{
					$status_img = "未";
					$str_img_allow = "<input type=\"checkbox\" name=\"allow[]\" value=\"{$item['id']}\">";
				}
			}else{
				$str_img = "&nbsp;";
				$status_img = "&nbsp;";
				$str_img_allow = "&nbsp;";
			}
			$id_comment = "comment" . $item['id'];
			if($item['ref'] == 0){
				$res_cnt = 0;
				$write_flg = 1;
				$list_detail .= <<<EOM
<tr>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="30" align="center"><input type="checkbox" name="delete[]" value="{$item['id']}"></td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="30" align="center"><input type="radio" name="modify[]" value="{$item['id']}"></td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="30" nowrap align="center">{$item['id']}</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="30" align="center">親</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="100" align="left"><a href="#" onclick="expand('{$id_comment}'); return false;">{$item['title']}</a></td>
  <td bgcolor="#FFFFFF" class="bg_article_top" align="left">
<div id="{$id_comment}" style="display: none;">{$comment}</div>
</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="80" nowrap align="center">{$name_tag}</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="100" nowrap align="center">{$item['date']}</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="30" nowrap align="center">{$str_img}</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="30" nowrap align="center">{$status_img}</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" width="50" nowrap align="center">{$str_img_allow}</td>
  <td bgcolor="#FFFFFF" class="bg_article_top" align="left">{$item['host']}</td>
</tr>\n
EOM;
			}else{
				$res_cnt++;
				if(($res_cnt % 2) == 1){
					$bgcolor = $CNF['res_bgcolor'];
				}else{
					$bgcolor = "#FFFFFF";
				}
				$list_detail .= <<<EOM
<tr>
  <td bgcolor="{$bgcolor}" width="30" align="center"><input type="checkbox" name="delete[]" value="{$item['id']}"></td>
  <td bgcolor="{$bgcolor}" width="30" align="center"><input type="radio" name="modify[]" value="{$item['id']}"></td>
  <td bgcolor="{$bgcolor}" width="30" nowrap align="center">{$item['id']}</td>
  <td bgcolor="{$bgcolor}" width="30" align="center"></td>
  <td bgcolor="{$bgcolor}" width="100" align="left"><a href="#" onclick="expand('{$id_comment}'); return false;">{$item['title']}</a></td>
  <td bgcolor="{$bgcolor}" align="left">
<div id="{$id_comment}" style="display: none;">{$comment}</div>
</td>
  <td bgcolor="{$bgcolor}" width="80" nowrap align="center">{$name_tag}</td>
  <td bgcolor="{$bgcolor}" width="100" nowrap align="center">{$item['date']}</td>
  <td bgcolor="{$bgcolor}" width="30" nowrap align="center">{$str_img}</td>
  <td bgcolor="{$bgcolor}" width="30" nowrap align="center">{$status_img}</td>
  <td bgcolor="{$bgcolor}" width="50" nowrap align="center">{$str_img_allow}</td>
  <td bgcolor="{$bgcolor}" align="left">{$item['host']}</td>
</tr>\n
EOM;
			}
		}
	}
	$db->close();
	$list_detail .= "</table><br></form>\n";

	if($rows_all < $pagenow * PAGEVIEW){
		$num_end = $rows_all;
	}else{
		$num_end = $pagenow * PAGEVIEW;
	}
	foreach(array('rows_all', 'num_start', 'num_end') as $key){
		$key_new = $key . "_format";
		$$key_new = str_replace(",", "&#44;", number_format($$key));
	}

	// ページコントロール
	$argv = "{$script_name4html}?";
	$pageing = $num_start_format."&nbsp;-&nbsp;".$num_end_format."&nbsp;(&nbsp;".$rows_all_format."&nbsp;件中&nbsp;)<br><br>\n";
	$pages_str = get_control_pages($rows_all,$pagenow,$num_start,$num_end,"",$argv,$pageing,PAGEVIEW,PAGE_CONTROL);

	$notice = $SPAM['js'] ? $msg_noscript : "";

	require(PATH_TEMPLATE."do_login.html");
}
#--------------------------------#
#  修正フォーム表示（管理モード）#
#--------------------------------#
function modify(){
	global $CNF,$COLORS,$homeurl,$REG,$SPAM,$script_name4html,$msg_noscript;

	if(!isset($_POST['modify'][0]) || intval($_POST['modify'][0]) < 1){
		error("編集したい記事にチェックが入っていません、LINE=".__LINE__);
	}

	$id = (int)$_POST['modify'][0];

	check_user_cookie($CNF['cookie_name'],ADMIN_PASS);

	set_tracking();
	set_session();
	$ticket4html = t2h($_SESSION['ticket']);

	$id = intval($_POST['modify'][0]);
	$db = new DB(DBHOST,DBUSER,DBPASS,DBNAME);
	$sql = "SELECT * FROM ".DBPREFIX."master WHERE id = {$id}";
	$rows = $db->get_count($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
	if(!$rows){	error("該当No.が存在しません");	}
	$sql = str_replace("count(*)", "*", $sql);
	$item = $db->fetch_array_assoc($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
	$db->Close();

	$post_pass_md5 = md5(ADMIN_PASS);
	$item['comment'] = h2t($item['comment']);
	$url_style = '(https?|ftp)(://[[:alnum:]\+\$\;\?\.%,!#~*/:@&=_-]+)';
	$item['comment'] = ereg_replace("<a href=\"{$url_style}\" target=\"".TARGET."\">{$url_style}</a>","\\1\\2",$item['comment']);
	$str_check_del = empty($item['img_ex']) ? "" : "\n&nbsp;&nbsp;削除確認<input type=\"checkbox\" name=\"check_del\" value=\"on\">";

	$str_form = "";

	if($SPAM['js']){
		$notice = $msg_noscript;
		$path_parts = pathinfo($_SERVER['SCRIPT_NAME']);
		$dirname = $path_parts['dirname'] . "/";
		$str_form .= "<form action=\"".t2h($dirname)."dummy.php\" method=\"post\" enctype=\"multipart/form-data\" name=\"form1\" id=\"form1\" onSubmit=\"return checkForm(0,{$SPAM['js']});\">\n";
		$str_form .= "<input type=\"hidden\" name=\"script\" value=\"{$script_name4html}\">\n";
	}else{
		$notice = "";
		$str_form .= "<form action=\"{$script_name4html}\" method=\"post\" enctype=\"multipart/form-data\" name=\"form1\" id=\"form1\" onsubmit=\"return checkForm({$REG['check']},{$SPAM['js']});\">\n";
	}
	$allow_max_upload = (int)ALLOW_MAX_UPLOAD;
	$str_form .= <<<EOM
<input type="hidden" name="mode" value="do_modify">
<input type="hidden" name="id" value="{$id}">
<input type="hidden" name="ref" value="{$item['ref']}">
<input type="hidden" name="post_pass" value="{$post_pass_md5}">
<input type="hidden" name="old_pass" value="{$item['pass']}">
<input type="hidden" name="old_name" value="{$item['name']}">
<input type="hidden" name="ticket" value="{$ticket4html}">
<input type="hidden" name="MAX_FILE_SIZE" value="{$allow_max_upload}">
<table border="0" cellpadding="0" cellspacing="0" width="450">
<tr><td width="100%">
<table border="0" width="100%" cellspacing="1" cellpadding="2">
<tr><td nowrap align="right"><b>名前：</b></td><td align="left"><input type="text" name="name" size="30"><font color="#cc0000">（修正する場合のみ記入）</font></td></tr>
<tr><td nowrap align="right"><b>Email：</b></td><td align="left"><input type="text" name="email" size="30" value="{$item['email']}"></td></tr>
<tr><td nowrap align="right"><b>タイトル：</b></td><td align="left"><input type="text" name="title" size="40" value="{$item['title']}"></td></tr>
<tr><td nowrap align="right"><font color="#CC0000">*</font><b>メッセージ：</b></td><td align="left"><textarea rows="7" name="comment" cols="54">{$item['comment']}</textarea></td></tr>
<tr><td nowrap align="right" valign="top"><b>画像ファイル：</b></td><td align="left"><input type="file" name="upfile" size="40">{$str_check_del}
<br><font color="#cc0000">（修正する場合のみ指定）</font></td></tr>
<tr><td nowrap align="right"><b>フォントカラー：</b></td>\n<td align="left">\n
EOM;
for($i = 0; $i < count($COLORS); $i++){
	if($i == $item['color']){
		$str_form .= "<input type=\"radio\" name=\"color\" value=\"$i\" checked><font color=\"{$COLORS[$i]}\">■</font>\n";
	}else{
		$str_form .= "<input type=\"radio\" name=\"color\" value=\"$i\"><font color=\"{$COLORS[$i]}\">■</font>\n";
	}
}
	$str_form .= <<<EOM
</td></tr>
<tr><td nowrap align="right"><b>パスワード：</b></td>
<td align="left"><input type="password" name="pass" size="10" maxlength="8"><font color="#cc0000">（修正する場合のみ記入、半角英数8文字以内）</font></td></tr>\n
EOM;

	preg_match('/\((.*)?\)/', ALLOW_UPFILE_EXTENSIONS, $matches);
	$extension_arr = split("\|", $matches[1]);
	for($i = 0,$str_extension = ""; $i < count($extension_arr); $i++){
		if($extension_arr[$i] == "jpeg"){	continue; }
		if(!empty($str_extension)){	$str_extension .= "、"; }
		$str_extension .= $extension_arr[$i];
	}
	$max_upload = ceil(ALLOW_MAX_UPLOAD/1024);
	$img_w = IMG_W;
	$img_h = IMG_H;
	$str_form .= <<<EOM
<tr><td colspan="2" align="left">
  <ul>アップロード出来る画像
  <li>添付可能ファイル：{$str_extension}</li>
  <li>最大アップロードサイズ：{$max_upload}KB</li>
  <li>画像サイズ：横{$img_w}px、縦{$img_h}pxを超えると縮小表示されます。</li>
  </ul>
</td></tr>
<tr><td colspan="2" align="center" height="50">
<input type="submit" name="submit" value="修正する">&nbsp;<input type="reset" value="リセット">
</td></tr>
</table>
</form>\n
EOM;
	require(PATH_TEMPLATE."modify.html");
}
#------------------#
#  データ修正処理  #
#------------------#
function do_modify(){
	global $CNF,$homeurl,$REG,$SPAM,$script_name4html;

	check_referer();
	check_tracking();
	check_session();

	$_POST['id'] = intval($_POST['id']);
	$trip_input = "";

if($_POST['name'] != ""){
	if(strstr($_POST['name'], TRIP_PAUSE)){
		list($_POST['name'],$trip_input) = explode(TRIP_PAUSE, $_POST['name']);
		if($trip_input == ""){	error("トリップ（個人識別キー）が入力されていません。\"".TRIP_PAUSE."\"の後に好きな文字列を入力するか、\"".TRIP_PAUSE."\"を消して下さい、LINE=".__LINE__); }
	}
	if(strlen(mb_convert_encoding($_POST['name'], "EUC-JP", "UTF-8")) > (NAME_MAX*2)){
		error("名前が全角".NAME_MAX."文字を超えています、LINE=".__LINE__);
	}elseif(strstr($_POST['name'], TRIP_SIGN)){
		error("名前（ハンドルネーム）に\"".TRIP_SIGN."\"は使えません。トリップ機能で使われます、LINE=".__LINE__);
	}
}
	if(strlen(mb_convert_encoding($_POST['title'], "EUC-JP", "UTF-8")) > (TITLE_MAX*2)){
		error("タイトルが全角".TITLE_MAX."文字を超えています、LINE=".__LINE__);
	}elseif(strlen(mb_convert_encoding($_POST['comment'], "EUC-JP", "UTF-8")) > (COM_MAX*2)){
		error("メッセージが全角".COM_MAX."文字を超えています、LINE=".__LINE__);
	}elseif($_POST['comment'] == ""){
		error("メッセージが入力されていません、LINE=".__LINE__);
	}elseif($_POST['email'] != "" && !preg_match('/[\w.-]+\@[\w.-]+\.[a-zA-Z]{2,6}/', $_POST['email'])){
		error("Ｅメールの入力内容が正しくありません、LINE=".__LINE__);
	}elseif(!$SPAM['single'] && !preg_match('/[\xc0-\xf7][\x80-\xbf]/', $_POST['comment'])){
		error("半角文字のみの投稿は禁止しています、LINE=".__LINE__);
	}elseif(!$SPAM['url'] && preg_match('/http:\/\//', $_POST['comment'])){
		error("URLを含む投稿は禁止しています。<br>URLを投稿した場合は、頭の「h」を除いた「ttp://」から始めるようにして再度投稿して下さい、LINE=".__LINE__);
	}

	check_user_cookie($CNF['cookie_name'],ADMIN_PASS);

	$db = new DB(DBHOST,DBUSER,DBPASS,DBNAME);

	foreach(array('name', 'old_name', 'title', 'comment') as $key){	$_POST[$key] = $db->escape_string($_POST[$key]); }
	// トリップ処理
	if($trip_input != ""){
		$trip_flg = 1;
		$trip_enc = substr(md5($trip_input), 0, TRIP_LENGTH);
		$_POST['name'] .= TRIP_SIGN.$trip_enc;
	}

	// 時間を取得
	$date = gmdate("Y-m-d H:i:s",time()+9*60*60);
	$lastmodify = gmdate("YmdHis",time()+9*60*60);
	// パスワードの暗号化
	if($_POST['pass'] == ""){
		$pass = $_POST['old_pass'];
		$_POST['pass'] = "変更無";
	}else{
		$pass = md5($_POST['pass']);
	}
	// 名前のセット
	if($_POST['name'] == ""){
		$_POST['name'] = $_POST['old_name'];
		$name_disp = "変更無";
	}else{
		$name_disp = $_POST['name'];
	}

	//現在時刻
	$now = time();
	$host = getenv("REMOTE_HOST");
	$addr = getenv("REMOTE_ADDR");
	if($host == "" || $host == $addr){	$host = @gethostbyaddr($addr);	}

	// 管理人を名乗る偽者チェック
	if(strstr($_POST['name'], "管理人")){
		if($trip_flg){
			if(TRIP_MASTER == ""){
				if($_POST['pass'] != ADMIN_PASS){
					error("名前に管理人と使う場合、修正・削除用パスワードに管理用パスワードを入力して下さい、LINE=".__LINE__);
				}
			}elseif($trip_input != TRIP_MASTER){
				error("管理人が使う、トリップ（個人識別キー）が間違っています、LINE=".__LINE__);
			}
		}else{
			if($_POST['pass'] != ADMIN_PASS){
				error("名前に管理人と使う場合、修正・削除用パスワードに管理用パスワードを入力して下さい、LINE=".__LINE__);
			}
		}
	}

	// ファイルアップロード用サブルーチン
	require_once(PATH_LIB."upload.php");

	// アップロードファイルチェック
	$img_arr = check_uploaded_image();

	// リンク自動変換
	if(AUTO_LINK){	link_make($_POST['comment']);	}

	$sql = "SELECT count(*) FROM ".DBPREFIX."master WHERE id = {$_POST['id']}";
	$rows = $db->get_count($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
	if($rows == 0){	error("該当No.が存在しません、LINE=".__LINE__);	}
	$sql = str_replace("count(*)", "pass", $sql);
	$item = $db->fetch_array_assoc($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
	if(!$SPAM['nopass'] && empty($item['pass']) && $_POST['post_pass'] != md5(ADMIN_PASS)){
		error("パスワードを設定していない投稿は、修正・削除を許可していません、LINE=".__LINE__);
	}
	if($_POST['post_pass'] != $item['pass'] && $item['pass'] != "" && $_POST['post_pass'] != md5(ADMIN_PASS)){
		error("パスワードが違います、LINE=".__LINE__);
	}

	$result = $db->transaction_begin();

	if(isset($_POST['check_del']) && $_POST['check_del'] == "on"){
		$flag_del_img = true;
		$sql = "SELECT count(*) FROM ".DBPREFIX."master WHERE id = {$_POST['id']}";
		$rows = $db->get_count($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
		if($rows == 0){	error("該当No.が存在しません、LINE=".__LINE__);	}
		$sql = str_replace("count(*)", "img_ex", $sql);
		$item = $db->fetch_array_assoc($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
		if(!empty($item['img_ex'])){
			$filename = PATH_IMG . $_POST['id'] . "." . $item['img_ex'];
			if(file_exists($filename)){
				if(!unlink($filename)){	error("unlink Error: ".t2h($filename)); }
			}
			$filename = PATH_IMG . $_POST['id'] . "_s." . $item['img_ex'];
			if(file_exists($filename)){
				if(!unlink($filename)){	error("unlink Error: ".t2h($filename)); }
			}
		}
	}else{
		$flag_del_img = false;
	}

	$sql = "UPDATE ".DBPREFIX."master SET ";
	$sql .= "date='{$date}', ";
	$sql .= "name='{$_POST['name']}', ";
	$sql .= "email='{$_POST['email']}', ";
	$sql .= "title='{$_POST['title']}', ";
	$sql .= "comment='{$_POST['comment']}', ";
	$sql .= "color=".intval($_POST['color']).", ";
	if(empty($img_arr)){
		if($flag_del_img){
			$sql .= "img_ex='', ";
			$sql .= "img_w=0, ";
			$sql .= "img_h=0, ";
			$sql .= "img_s=0, ";
			$sql .= "img_check=0, ";
		}
	}else{
		$width = (int)$img_arr['width_s'];
		$height = (int)$img_arr['height_s'];
		$extention = $db->escape_string($img_arr['extention']);
		$img_s = $img_arr['resize'] ? 1 : 0;
		$sql .= "img_ex='{$extention}', ";
		$sql .= "img_w={$width}, ";
		$sql .= "img_h={$height}, ";
		$sql .= "img_s={$img_s}, ";
		$sql .= "img_check=0, ";
	}
	$sql .= "pass='{$pass}', ";
	$sql .= "host='{$host}', ";
	$sql .= "lastmodify={$lastmodify} ";
	$sql .= " WHERE id={$_POST['id']}";
	$result = $db->query($sql);

	// 画像アップロード
	do_upload_image($_POST['id'],$img_arr);

	$result = $db->transaction_commit();
	$db->close();

	$name_disp = stripslashes($name_disp);
	foreach(array('title', 'comment') as $key){	$_POST[$key] = stripslashes($_POST[$key]); }

	// 修正完了メッセージ出力
	$msg_title = "修正完了";
	$msg_detail = <<<EOM
<p><b>修正完了</b></p>
<table border="0" cellpadding="0" cellspacing="0" width="450">
<tr><td width="100%" align="left">
<table border="0" width="100%" cellspacing="1" cellpadding="3" bgcolor="#c0c0c0">
<tr><td width="25%" bgcolor="#FFFFFF"><b>名前</b></td>
<td width="75%" bgcolor="#FFFFFF">{$name_disp}</td></tr>
<tr><td width="25%" bgcolor="#FFFFFF"><b>Email</b></td>
<td width="75%" bgcolor="#FFFFFF">{$_POST['email']}</td></tr>
<tr><td width="25%" bgcolor="#FFFFFF" nowrap><b>タイトル</b></td>
<td width="75%" bgcolor="#FFFFFF">{$_POST['title']}</td></tr>
<tr><td width="25%" bgcolor="#FFFFFF" nowrap><b>メッセージ</b><font color="#CC0000">*</font></td>
<td width="75%" bgcolor="#FFFFFF">{$_POST['comment']}</td></tr>
<tr><td width="25%" bgcolor="#FFFFFF" nowrap><b>パスワード</b></td>
<td width="75%" bgcolor="#FFFFFF">{$_POST['pass']}</td></tr>
</table>
</td></tr>
</table>
<p align="center"><a href="{$script_name4html}">管理画面に戻る</a></p>
EOM;

	require(PATH_TEMPLATE."finish.html");
}
#----------------#
#  記事一括削除  #
#----------------#
function delete(){
	global $CNF,$script_name4html;

	if(!isset($_POST['delete']) || count($_POST['delete']) == 0){
		error("削除したい記事にチェックが入っていません、LINE=".__LINE__);
	}

	check_user_cookie($CNF['cookie_name'],ADMIN_PASS);

	$db = new DB(DBHOST,DBUSER,DBPASS,DBNAME);

	$status = true;
	$result = $db->transaction_begin();

	for($i = 0,$id_arr = array(); $i < count($_POST['delete']); $i++){
		$id = (int)$_POST['delete'][$i];
		$sql = "SELECT count(*) FROM ".DBPREFIX."master WHERE id = {$id} OR ref = {$id}";
		$rows = $db->get_count($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
		if($rows == 0){	error("該当No.が存在しません、LINE=".__LINE__);	}
		$sql = str_replace("count(*)", "id,img_ex", $sql);
		$items = $db->get_rows($sql,$_SERVER['SCRIPT_NAME'],__FUNCTION__,__LINE__);
		foreach($items as $item){
			if(!in_array($item['id'], $id_arr) && !empty($item['img_ex'])){
				array_push($id_arr, $item['id']);
				$filename = PATH_IMG . $item['id'] . "." . $item['img_ex'];
				if(file_exists($filename)){
					if(!unlink($filename)){	error("unlink Error: ".t2h($filename)); }
				}
				$filename = PATH_IMG . $item['id'] . "_s." . $item['img_ex'];
				if(file_exists($filename)){
					if(!unlink($filename)){	error("unlink Error: ".t2h($filename)); }
				}
			}
		}
		$sql = "DELETE FROM ".DBPREFIX."master WHERE id = {$id} OR ref = {$id}";
		$result = $db->query($sql);
		if(!$result){	$status = false;	}
	}

	if($status){
		$result = $db->transaction_commit();
	}else{
		$result = $db->transaction_rollback();
		error("記事削除中にエラーが発生しました、LINE=".__LINE__);
	}
	$db->close();

	// 記事削除完了メッセージ出力
	$msg_title = "記事削除完了";
	$msg_detail = <<<EOM
<p><b>記事削除完了しました。</b></p>
<p align="center"><a href="{$script_name4html}">管理画面に戻る</a></p>
EOM;
	require(PATH_TEMPLATE."finish.html");
}
#------------#
#  画像承認  #
#------------#
function allow(){
	global $CNF,$script_name4html;

	if(!isset($_POST['allow']) || count($_POST['allow']) == 0){
		error("画像承認したいデータにチェックが入っていません、LINE=".__LINE__);
	}

	check_user_cookie($CNF['cookie_name'],ADMIN_PASS);

	$db = new DB(DBHOST,DBUSER,DBPASS,DBNAME);

	$status = true;
	$result = $db->transaction_begin();

	for($i = 0; $i < count($_POST['allow']); $i++){
		$id = (int)$_POST['allow'][$i];
		$sql = "UPDATE ".DBPREFIX."master SET img_check = 1 WHERE id = {$id}";
		$result = $db->query($sql);
		if(!$result){	$status = false;	}
	}

	if($status){
		$result = $db->transaction_commit();
	}else{
		$result = $db->transaction_rollback();
		error("画像承認中にエラーが発生しました、LINE=".__LINE__);
	}
	$db->close();

	// 画像承認完了メッセージ出力
	$msg_title = "画像承認完了";
	$msg_detail = <<<EOM
<p><b>画像承認完了しました。</b></p>
<p align="center"><a href="{$script_name4html}">管理画面に戻る</a></p>
EOM;
	require(PATH_TEMPLATE."finish.html");
}
#------------------#
#  ログイン        #
#------------------#
function login($status=false){
	global $CNF;

	// パスワードチェック
	if($status == false){
		check_pass($CNF['cookie_name'],ADMIN_PASS);
	}else{
		check_user_cookie($CNF['cookie_name'],ADMIN_PASS);
	}
	show_top_html_admin();
}
#----------------------#
#  パスワードチェック  #
#----------------------#
function check_pass($cookie_name,$pass_config){
	global $CNF;

	if(empty($_POST['pass'])){	error("パスワードが入力されていません、LINE=".__LINE__); }
	$pass_encrypted = sha1($_POST['pass']);
	// パスワード照合
	if($_POST['pass'] != $pass_config){	error("パスワード：".t2h($_POST['pass'])."は違います、LINE=".__LINE__); }

	// Cookieセット
	set_user_cookie($cookie_name,$pass_encrypted,$CNF['secret_key']);
}
#----------------#
#  Cookieセット  #
#----------------#
function set_user_cookie($cookie_name,$pass_encrypted){
	global $CNF;

	if(isset($_COOKIE[$cookie_name])){	setcookie($cookie_name); }
	$ip = $_SERVER['REMOTE_ADDR'];
	$ua = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "";
	$cookie_val = $pass_encrypted.":".sha1($ip."-".$CNF['secret_key']).":".sha1($ua."-".$CNF['secret_key']);
	if(!setcookie($cookie_name, $cookie_val)){	error("クッキー送信に失敗しました。 LINE=".__LINE__); }
}
#------------------#
#  Cookieチェック  #
#------------------#
function check_user_cookie($cookie_name,$pass){
	global $CNF;

	if(!isset($_COOKIE[$cookie_name]) || $_COOKIE[$cookie_name] == ""){
		error("クッキーを有効にしてから、もう一度ログインし直してご利用下さい、LINE=".__LINE__);
	}
	list($pass_encrypted,$ip_cookie,$ua_cookie) = explode(":", $_COOKIE[$cookie_name]);
	$ip = $_SERVER['REMOTE_ADDR'];
	if(sha1($ip."-".$CNF['secret_key']) != $ip_cookie){	error("IPアドレスの変更は許可していません、LINE=".__LINE__); }
	$ua = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "";
	if(sha1($ua."-".$CNF['secret_key']) != $ua_cookie){	error("ユーザーエージェントの変更は許可していません、LINE=".__LINE__); }
	if($pass_encrypted != sha1($pass)){	error("パスワードが違います。もう一度ログインし直してご利用下さい、LINE=".__LINE__); }
	return $pass_encrypted;
}
#--------------#
#  Cookie削除  #
#--------------#
function delete_user_cookie($cookie_name){

	// 管理用Cookie削除
	setcookie($cookie_name);
}
#------------------#
#  ログアウト      #
#------------------#
function logout(){
	global $CNF;

	delete_user_cookie($CNF['cookie_name']);

	header("Location: index.php");
}
#----------------#
#  デコード処理  #
#----------------#
function decode(){

	if($_SERVER['REQUEST_METHOD'] == "GET"){	error("不正なリクエストです、LINE=".__LINE__); }

	foreach($_POST as $key => $value){
		// バックスラッシュの排除
		if(get_magic_quotes_gpc()){	$value = stripslashes($value); }

		// タグ処理
		$value = htmlspecialchars($value);

		// 区切り文字","をタグ用に処理
		$value = str_replace(",", "&#44;", $value);

		// 改行処理
		if($key == "comment"){
			$value = preg_replace('/[\t\0]/', '', $value);
			$value = str_replace("\r\n", "<br>", $value);
			$value = str_replace("\r", "<br>", $value);
			$value = str_replace("\n", "<br>", $value);
		}else{
			$value = preg_replace('/[\r\n\t\0]/', '', $value);
		}
		$value = trim($value);
		$_POST[$key] = $value;
	}
}
?>